Fix click event handling in mobile view after closing flyout menu

2023-12-09 14:14 - salman mp

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 5.0.8   

Resolution: Fixed Affected version: 5.1.1

Description

In the mobile view, after opening flyout menu, there is a javascript that prevents click event on #main element. After closing menu it

must reset to normal bahaviour, but despite mentioned in Patch #30448#note-13: Remove wrapper2 and wrapper3 wrapping

containers   this is not patched yet.

Index: public/javascripts/responsive.js

<+>UTF-8

===================================================================

diff --git a/public/javascripts/responsive.js b/public/javascripts/responsive.js

--- a/public/javascripts/responsive.js    (revision 41895:183d6d070b7e204d024b7f30fd0dac75ff60ef70

)

+++ b/public/javascripts/responsive.js    (revision 41895+:183d6d070b7e+)

@@ -11,7 +11,7 @@

 function closeFlyout() {

   $('html').removeClass('flyout-is-active');

-  $('#wrapper').off('click');

+  $('#main').off('click');

 }

Related issues:

Related to Redmine - Patch #30448: Remove wrapper2 and wrapper3 wrapping cont... Closed

Associated revisions

Revision 22670 - 2024-02-02 01:54 - Go MAEDA

Fix click event handling in mobile view after closing flyout menu (#39802).

Patch by salman mp (@salmanmp) and Mizuki ISHIKAWA (@ishikawa999).

Revision 22673 - 2024-02-03 01:51 - Go MAEDA

Merged r22670 from trunk to 5.1-stable (#39802).

Revision 22674 - 2024-02-03 01:52 - Go MAEDA

Merged r22670 from trunk to 5.0-stable (#39802).

History

#1 - 2023-12-09 14:27 - salman mp

Better suggestion to prevent showing project select jump-box when flyout menu is showing.

Index: public/javascripts/responsive.js

===================================================================

diff --git a/public/javascripts/responsive.js b/public/javascripts/responsive.js

--- a/public/javascripts/responsive.js    (revision 41895:183d6d070b7e204d024b7f30fd0dac75ff60ef70)

+++ b/public/javascripts/responsive.js    (revision 41895+:183d6d070b7e+)

@@ -2,7 +2,7 @@

 function openFlyout() {

   $('html').addClass('flyout-is-active');

-  $('#main').on('click', function(e){

+  $('#main, #header').on('click', function(e){

     e.preventDefault();
     e.stopPropagation();

     closeFlyout();

@@ -11,7 +11,7 @@

 function closeFlyout() {

   $('html').removeClass('flyout-is-active');

-  $('#wrapper').off('click');

+  $('#main, #header').off('click');

 }

 

#2 - 2023-12-25 06:22 - Mizuki ISHIKAWA

- File counting-of-click-event-function-calls.gif added

salman mp wrote:

In the mobile view, after opening flyout menu, there is a javascript that prevents click event on #main element. After closing menu it must reset to

normal bahaviour, but despite mentioned in Patch #30448#note-13: Remove wrapper2 and wrapper3 wrapping containers   this is not patched

yet.

 I've confirmed the issue you've pointed out. In the current code, as shown in the attached counting-of-click-event-function-calls.gif , the function added

by openFlyout keeps accumulating.

Regarding #note-1, I agree it should be changed. When the flyout menu is open, opening the jump box doesn't fully display it and it doesn't function

properly. Therefore, when clicking on #header, it's better to close the flyout menu rather than opening the jump box.

#3 - 2023-12-25 06:39 - Mizuki ISHIKAWA

It is better to specify a namespace to avoid other event handlers being removed.

https://api.jquery.com/off/#:~:text=Unbind%20all%20delegated%20event%20handlers%20by%20their%20namespace

diff --git a/public/javascripts/responsive.js b/public/javascripts/responsive.js

index 9dc4db4e7..e5515dbac 100644

--- a/public/javascripts/responsive.js

+++ b/public/javascripts/responsive.js

@@ -19,7 +19,7 @@

 function openFlyout() {

   $('html').addClass('flyout-is-active');

-  $('#main').on('click', function(e){

+  $('#main, #header').on('click.close-flyout', function(e){

     e.preventDefault();

     e.stopPropagation();

     closeFlyout();

@@ -28,7 +28,7 @@ function openFlyout() {

 function closeFlyout() {

   $('html').removeClass('flyout-is-active');

-  $('#wrapper').off('click');

+  $('#main, #header').off('click.close-flyout');

 }

#4 - 2023-12-25 16:23 - salman mp

Mizuki ISHIKAWA wrote in #note-3:

It is better to specify a namespace to avoid other event handlers being removed.

https://api.jquery.com/off/#:~:text=Unbind%20all%20delegated%20event%20handlers%20by%20their%20namespace

[...]

 That's good. Thanks.

#5 - 2023-12-26 00:30 - Go MAEDA

- Related to Patch #30448: Remove wrapper2 and wrapper3 wrapping containers added

#6 - 2023-12-26 00:31 - Go MAEDA

- Target version set to 5.0.8

Setting the target version to 5.0.8.
#7 - 2024-02-02 01:55 - Go MAEDA

- Subject changed from Preventing click event on mobile view after flyout menu open and then closed to Fix click event handling in mobile view after

closing flyout menu

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22670.

#8 - 2024-02-03 01:52 - Go MAEDA

- Status changed from Resolved to Closed

Thank you for your contribution.

Files

counting-of-click-event-function-calls.gif 511 KB 2023-12-25 Mizuki ISHIKAWA
